# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import vecmath
import weaponlib
import gamethread

import os

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "Daggers by L'In20Cible"
g_informations["version"] = "1.2"
g_informations["date"] = "2010-07-04"
g_informations["author"] = "L\'in20Cible"
g_informations["url"] = "http://addons.eventscripts.com/addons/view/daggers/"
g_informations["basename"] = "daggers"

es.ServerVar((g_informations["basename"] + "_version"), (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_options = {
   "enable": [1, "daggers_enable <1/0> -- Active/Désactive les fonctionnalités du script daggers."],
   "effects": [0, "daggers_effects <1/0> -- Active/Désactive l'effet sur les couteaux lorsqu'ils n'appartiennent à aucun joueur."],
   "friendlyfire": [0, "daggers_friendlyfire <1/0> -- Active/Désactive le tir fraternel."],
   "distance": [750, "daggers_distance <int> -- Définit la distance du lancé."],
   "sounds": [1, "daggers_sounds <1/0> -- Active/Désactive les sons lancés par le script daggers."],
   }
for option in g_options:
   g_options[option] = es.ServerVar((g_informations["basename"] + "_" + option), g_options[option][0], g_options[option][1])
   
   
# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   __init__()
   es.addons.registerTickListener(TickListener)
   es.addons.registerClientCommandFilter(ClientCommandFilter)
   
   
def __init__():
   global g_players, g_roundover
   g_players = list()
   g_roundover = False
   path = os.path.join(str(es.server_var["eventscripts_gamedir"]), "cfg", "eventscripts", g_informations["basename"], "configuration.cfg").replace(os.sep, "/")
   if not os.path.isfile(path):
      return
   es.mexec(path.replace(str(es.server_var["eventscripts_gamedir"]).replace(os.sep, "/"), ".."))
   
   
def unload():
   es.addons.unregisterTickListener(TickListener)
   es.addons.unregisterClientCommandFilter(ClientCommandFilter)
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetViewProp(userid):
   returnvalue = -1
   CheatExec(userid, "ent_setname daggers_viewed_prop")
   for index in es.createentitylist():
      if (es.entitygetvalue(index, "targetname") != "daggers_viewed_prop"):
         continue
      returnvalue = index
      es.entitysetvalue(index, "targetname", "")
      break
   return returnvalue
   
   
def GetViewPlayer(userid):
   returnvalue = -1
   index = GetViewProp(userid)
   for player in es.getUseridList():
      if (index != es.createplayerlist(player)[player]["index"]):
         continue
      returnvalue = player
      break
   return returnvalue
   
   
def CheatExec(userid, string):
   if not int(es.server_var["sv_cheats"]):
      es.forcevalue("sv_cheats", 1)
      es.sexec(userid, string)
      es.forcevalue("sv_cheats", 0)
   else:
      es.server.cmd("es_xsexec %i %s" % (userid, string))
      
      
def GetViewCoord(userid):
   returnvalue = (0.0, 0.0, 0.0)
   entities = es.createentitylist("prop_dynamic")
   CheatExec(userid, "prop_dynamic_create props_c17/tv_monitor01_screen.mdl")
   for index in es.createentitylist("prop_dynamic"):
      if (index in entities):
         continue
      returnvalue = es.getindexprop(index, "CBaseEntity.m_vecOrigin").split(",")
      RemoveEntity(index)
      break
   return es.createvectorstring(*returnvalue)
   
   
def GetEyeCoord(userid):
   returnvalue = (0.0, 0.0, 0.0)
   x, y, z = es.getplayerlocation(userid)
   z = (z + 66.7)
   if (es.getplayerprop(userid, "CBasePlayer.localdata.m_Local.m_bDucked") % 2):
      z = (z - 16.1)
   return es.createvectorstring(x, y, z)
   
   
def RemoveEntity(index):
   userid = int(es.getuserid())
   if not es.exists("userid", userid) or (index not in es.createentitylist()) or (es.entitygetvalue(index, "classname") == "worldspawn"):
      return
   es.entitysetvalue(index, "targetname", index)
   es.fire(userid, index, "kill")
   
   
def MakeDamage(userid, attacker):
   if not int(g_options["friendlyfire"]) and (es.getplayerteam(userid) == es.getplayerteam(attacker)):
      return
   es.server.queuecmd("damage %s %s 32 %s" % (userid, es.getplayerprop(userid, "CBasePlayer.m_iHealth"), attacker))
   
   
def GetWeaponIndex(userid, weapon):
   returnvalue = -1
   for index in es.createentitylist(weapon):
      if (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != es.getplayerhandle(userid)):
         continue
      returnvalue = index
      break
   return returnvalue
   
   
def GetWeaponCount(userid):
   returnvalue = 0
   for index in es.createentitylist():
      classname = es.entitygetvalue(index, "classname")
      if (classname[:6] != "weapon") or (classname[7:] == "knife") or (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != es.getplayerhandle(userid)):
         continue
      returnvalue = (returnvalue + 1)
   return returnvalue
   
   
# ==================================================
# >> FONCTIONS D'APPELS
# ==================================================


def TickListener():
   if not int(g_options["enable"]) or not int(g_options["effects"]):
      return
   for index in es.createentitylist("weapon_knife"):
      if (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != -1):
         continue
      origin = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
      es.effect("energysplash", origin, origin, 0)
      
      
def ClientCommandFilter(userid, arguments):
   if int(g_options["enable"]) and not g_roundover and (arguments[0].lower() == "drop") and not es.getplayerprop(userid, "CBasePlayer.pl.deadflag") and (es.createplayerlist(userid)[userid]["weapon"] == "weapon_knife") and (userid not in g_players):
      g_players.append(userid)
      if GetWeaponCount(userid):
         index = GetWeaponIndex(userid, "weapon_knife")
         if (index != -1):
            es.cexec(userid, "lastinv")
            gamethread.delayed(0.2, RemoveEntity, index)
      else:
         es.give(userid, "player_weaponstrip")
         gamethread.delayed(0.2, es.fire, (userid, "player_weaponstrip", "strip"))
      origin = GetEyeCoord(userid)
      target = GetViewPlayer(userid)
      if (target != -1) and (vecmath.distance(origin, es.getplayerlocation(target)) < int(g_options["distance"])):
         gamethread.delayed(0.1, MakeDamage, (target, userid))
      vector = (vecmath.vector(es.createvectorfrompoints(origin, GetViewCoord(userid))) * int(g_options["distance"]))
      index = es.createentity("weapon_knife")
      outputs = {
         "origin"    : origin.replace(",", " "),
         "angles"    : es.createvectorstring(es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[0]"), es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[1]"), 0.0).replace(",", " "),
         "targetname": ("dagger_%i" % index)
         }
      for output in outputs:
         es.entitysetvalue(index, output, outputs[output])
      es.spawnentity(index)
      es.fire(userid, ("dagger_%i" % index), "wake")
      es.delayed(0, "es_xphysics active setvelocity %i %s" % (index, vector))
      if int(g_options["sounds"]):
         es.emitsound("entity", index, "weapons/iceaxe/iceaxe_swing1.wav", 1.0, 0.5)
      gamethread.delayed(1.0, g_players.remove, userid)
   return True
   
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   __init__()
   
   
def player_spawn(event_var):
   userid = int(event_var["userid"])
   if not int(g_options["enable"]) or (int(event_var["es_userteam"]) not in [2, 3]) or (GetWeaponIndex(userid, "weapon_knife") != -1):
      return
   es.give(userid, "weapon_knife")
   
   
def round_start(event_var):
   global g_roundover
   g_roundover = True
   
def round_freeze_end(event_var):
   global g_roundover
   g_roundover = False